class EventListener {
	String key;
	Function fn;
	EventListener({this.key, this.fn}) {

	}
}

class EventModel {

	Map<String, List<Function>> events = Map();

	onEvent(name, fn) {
		if(!events.containsKey(name)) {
			events[name] = List<Function>();
		}
		events[name].add(fn);
		return () {
			offEvent(name, fn);
		};
	}

	onEvents(Iterable<dynamic> events) {
		List<Function> unbindFns = List();
		for(var evenetListener in events) {
			var fn = onEvent(evenetListener["key"], evenetListener["fn"]);
			unbindFns.add(fn);
		}
		return () {
			unbindFns.forEach((fn) {
				Function.apply(fn, []);
			});
		};
	}

	offEvent(name, fn) {
		if(events.containsKey(name)) {
			List<Function> fns = events[name];
			fns.remove(fn);
		}
	}

	trigger(name, List<dynamic> args) {
		if(events.containsKey(name)) {
			List<Function> fns = events[name];
			fns.forEach((fn) {
				Function.apply(fn, args);
			});
		}
	}

}
