import 'package:flutter_test/flutter_test.dart';

import 'package:event_base/id_generator.dart';

void main() {
  test('genId', () {
    final idGenerator = IdGenerator();
    expect(idGenerator.genId(), 'o0');
    expect(idGenerator.genId(), 'o1');
    expect(idGenerator.genId(), 'o2');
    expect(idGenerator.genId(), 'o3');
    expect(idGenerator.genId(), 'o4');
    expect(idGenerator.genId(), 'o5');
    expect(idGenerator.genId(), 'o6');
    expect(idGenerator.genId(), 'o7');
    expect(idGenerator.genId(), 'o8');
    expect(idGenerator.genId(), 'o9');
    expect(idGenerator.genId(), 'oa');
    expect(idGenerator.genId(), 'ob');
    expect(idGenerator.genId(), 'oc');
    expect(idGenerator.genId(), 'od');
    expect(idGenerator.genId(), 'oe');
    expect(idGenerator.genId(), 'of');
    expect(idGenerator.genId(), 'o10');
  });

  test('reset', () {
  	final idGenerator = IdGenerator();
  	expect(idGenerator.genId(), 'o0');
    expect(idGenerator.genId(), 'o1');
    idGenerator.reset();
    expect(idGenerator.genId(), 'o0');
  });

  test('reset:withPrefix', () {
  	final idGenerator = IdGenerator(prefix: 'p');
  	expect(idGenerator.genId(), 'p0');
    expect(idGenerator.genId(), 'p1');
    idGenerator.reset();
    expect(idGenerator.genId(), 'p0');
  });
}
